
#include "mbed.h"
#include "EthernetInterface.h"
#include "SNTPClient.h"

#define ENABLE_NTP

#define INTERVAL            1.0

Ticker flipper;
tstamp g_seconds=0;
EthernetInterface eth;

void flip() {
    g_seconds += 1;
}

void baud(int baudrate) {
    Serial s(USBTX, USBRX);
    s.baud(baudrate);
}

int main (void)
{
    datetime time;
    int ret;
    uint8_t mac_addr[6] = {0x00, 0x08, 0xDC, 0x01, 0x02, 0x03}; 
	
    baud(115200);

    printf("#Wait a second...\r\n");
    eth.init(mac_addr); //Use DHCP
    eth.connect();
    printf("IP Address is %s\r\n", eth.getIPAddress());
    
#ifdef ENABLE_NTP
    SNTPClient sntp("time.nist.gov", 40);   // timezone: Korea, Republic of
    //SNTPClient sntp("kr.pool.ntp.org", 40);   // timezone: Korea, Republic of
    sntp.connect();

    do {
        ret = sntp.getTime(&time);
        wait(0.1);
    }while(ret != true);
    printf("1st %d/%d/%d %d:%d:%d \r\n", time.yy, time.mo, time.dd, time.hh, time.mm, time.ss);
#endif   

	flipper.attach(&flip, INTERVAL);
    
    while (true)
    {
#ifdef ENABLE_NTP
        sntp.calcdatetime(g_seconds);
        sntp.getTime2(&time);
        
        printf("%d/%d/%d %d:%d:%d\r\n", time.yy, time.mo, time.dd, time.hh, time.mm, time.ss);
#endif        

        wait(INTERVAL);
    }
}
